Subject: Re: [PATCH v3 4/4] powerpc/mpc5200: Add mpc5200-spi (non-PSC) device driver

From: Daniel Walker <[email-masked]>
Date: Sat, 26 Jul 2008 00:47:39 -0400

On Fri, 2008-07-25 at 22:45 -0400, Grant Likely wrote:
> On Fri, Jul 25, 2008 at 2:19 PM, Daniel Walker <[email-masked]> wrote:
> > On Fri, 2008-07-25 at 03:33 -0400, Grant Likely wrote:
> >
> >> +     if (status && (irq != NO_IRQ))
> >> +             dev_err(&ms->master->dev, "spurious irq, status=0x%.2x\n",
> >> +                     status);
> >> +
> >> +     /* Check if there is another transfer waiting */
> >> +     if (list_empty(&ms->queue))
> >> +             return FSM_STOP;
> >
> > I don't think doing list_empty outside the critical section is totally
> > safe.. You might want to move it down inside the spin_lock() section.
> 
> This should be fine.  This is the only place where items are dequeued,
> and it will only ever be called from the ISR or the work queue.  The
> work queue and IRQ will never be active at the same time (I'll add a
> comment to the fact).  It also looks like list_empty is perfectly safe
> to call without the protection of a spin lock (but somebody correct me
> if I'm out to lunch).  It doesn't dereference any of the pointers in
> the list_head structure.

The list_empty wouldn't crash, but the result isn't necessarily
accurate.

> >
> >> +     /* Get the next message */
> >> +     spin_lock(&ms->lock);
> >
> > The part that's a little confusing here is that the interrupt can
> > actually activate the workqueue .. So I'm wondering if maybe you could
> > have this interrupt driven any workqueue driven at the same time? If you
> > could then you would need the above to be
> > spin_lock_irq/spin_lock_irqsave ..
> 
> Ditto here, since the irq and workqueue are not enabled at the same
> time there is no worry about collision.

Why are you waking up the work queue from inside the irq handler? You
might also want to break out the handling from inside the irq handler
and call that from the workqueue, instead of re-calling the irq handler
function from the workqueue.. It's a little confusing from a context
perspective.

Daniel